---
title: Create Rule (Writeback)
description: The POST {{apiPath}}/v1/environments/{{envID}}/propagation/rules operation adds a new propagation rule resource to the specified environment resource. Writeback rules only operate on user records that have been provisioned inbound by the parent rule. Therefore, the population selection properties do not pertain to writeback rules. Available user attributes for any store can be obtained with the appropriate request found in Propagation Store Metadata and looking under userAttributes.
component: pingone-api
page_id: pingone-api:platform:identity-propagation-provisioning/propagation-rules/create-rule-writeback
canonical_url: https://developer.pingidentity.com/pingone-api/platform/identity-propagation-provisioning/propagation-rules/create-rule-writeback.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Rule (Writeback)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules
```

The `POST {{apiPath}}/v1/environments/{{envID}}/propagation/rules` operation adds a new propagation rule resource to the specified environment resource. Writeback rules only operate on user records that have been provisioned inbound by the parent rule. Therefore, the population selection properties do not pertain to writeback rules. Available user attributes for any store can be obtained with the appropriate request found in [Propagation Store Metadata](../propagation-store-metadata.html) and looking under `userAttributes`.

To visualize how a writeback rule is deployed, refer to the use case [Create a Workday propagation connection](../../../workflow-library/platform-sso-and-authorization/identity-propagation/create-a-workday-propagation-connection.html).

> **Collapse: Request Model**
>
> Refer to [Propagation rule data model](../propagation-rules.html#propagation-rule-data-model) for full property descriptions.
>
> | Property         | Type   | Required? |
> | ---------------- | ------ | --------- |
> | `description`    | String | Optional  |
> | `name`           | String | Required  |
> | `parentRule.id`  | String | Required  |
> | `plan.id`        | String | Required  |
> | `sourceStore.id` | String | Required  |
> | `targetStore.id` | String | Required  |

### Prerequisites

* [Create a propagation plan](../propagation-plans/create-plan.html) to get a `planID` for the endpoint and the body. Refer also to [Identity Propagation (Provisioning)](../../identity-propagation-provisioning.html), especially [Propagation Plans](../propagation-plans.html).

* [Create source and target propagation stores](../propagation-stores/create-store-aquera.html) to get a `sourceStoreID` and `targetStoreID` for the body. Refer also to [Identity Propagation (Provisioning)](../../identity-propagation-provisioning.html), especially [Propagation Stores](../propagation-stores.html).

* If using a population identifier in the `populationExpression`, or using the deprecated `population.id`, [Create a population](../../populations/create-population.html) to get a `popID` for the body. Refer also to [Populations](../../populations.html).

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "plan": {
        "id": "{{planID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{writebackStoreID}}"
    },
    "targetStore": {
        "id": "{{sourceStoreID}}"
    },
    "name": "Workday Writeback Rule",
    "description": "Workday writeback rule description",
    "parentRule": {
        "id": "{{parentRuleID}}"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "plan": {
        "id": "{{planID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{writebackStoreID}}"
    },
    "targetStore": {
        "id": "{{sourceStoreID}}"
    },
    "name": "Workday Writeback Rule",
    "description": "Workday writeback rule description",
    "parentRule": {
        "id": "{{parentRuleID}}"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""plan"": {" + "\n" +
@"        ""id"": ""{{planID}}""" + "\n" +
@"    }," + "\n" +
@"    ""environment"": {" + "\n" +
@"        ""id"": ""{{envID}}""" + "\n" +
@"    }," + "\n" +
@"    ""sourceStore"": {" + "\n" +
@"        ""id"": ""{{writebackStoreID}}""" + "\n" +
@"    }," + "\n" +
@"    ""targetStore"": {" + "\n" +
@"        ""id"": ""{{sourceStoreID}}""" + "\n" +
@"    }," + "\n" +
@"    ""name"": ""Workday Writeback Rule""," + "\n" +
@"    ""description"": ""Workday writeback rule description""," + "\n" +
@"    ""parentRule"": {" + "\n" +
@"        ""id"": ""{{parentRuleID}}""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules"
  method := "POST"

  payload := strings.NewReader(`{
    "plan": {
        "id": "{{planID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{writebackStoreID}}"
    },
    "targetStore": {
        "id": "{{sourceStoreID}}"
    },
    "name": "Workday Writeback Rule",
    "description": "Workday writeback rule description",
    "parentRule": {
        "id": "{{parentRuleID}}"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/propagation/plans/{{planID}}/rules HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "plan": {
        "id": "{{planID}}"
    },
    "environment": {
        "id": "{{envID}}"
    },
    "sourceStore": {
        "id": "{{writebackStoreID}}"
    },
    "targetStore": {
        "id": "{{sourceStoreID}}"
    },
    "name": "Workday Writeback Rule",
    "description": "Workday writeback rule description",
    "parentRule": {
        "id": "{{parentRuleID}}"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"plan\": {\n        \"id\": \"{{planID}}\"\n    },\n    \"environment\": {\n        \"id\": \"{{envID}}\"\n    },\n    \"sourceStore\": {\n        \"id\": \"{{writebackStoreID}}\"\n    },\n    \"targetStore\": {\n        \"id\": \"{{sourceStoreID}}\"\n    },\n    \"name\": \"Workday Writeback Rule\",\n    \"description\": \"Workday writeback rule description\",\n    \"parentRule\": {\n        \"id\": \"{{parentRuleID}}\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "plan": {
      "id": "{{planID}}"
    },
    "environment": {
      "id": "{{envID}}"
    },
    "sourceStore": {
      "id": "{{writebackStoreID}}"
    },
    "targetStore": {
      "id": "{{sourceStoreID}}"
    },
    "name": "Workday Writeback Rule",
    "description": "Workday writeback rule description",
    "parentRule": {
      "id": "{{parentRuleID}}"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "plan": {
      "id": "{{planID}}"
    },
    "environment": {
      "id": "{{envID}}"
    },
    "sourceStore": {
      "id": "{{writebackStoreID}}"
    },
    "targetStore": {
      "id": "{{sourceStoreID}}"
    },
    "name": "Workday Writeback Rule",
    "description": "Workday writeback rule description",
    "parentRule": {
      "id": "{{parentRuleID}}"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules"

payload = json.dumps({
  "plan": {
    "id": "{{planID}}"
  },
  "environment": {
    "id": "{{envID}}"
  },
  "sourceStore": {
    "id": "{{writebackStoreID}}"
  },
  "targetStore": {
    "id": "{{sourceStoreID}}"
  },
  "name": "Workday Writeback Rule",
  "description": "Workday writeback rule description",
  "parentRule": {
    "id": "{{parentRuleID}}"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "plan": {\n        "id": "{{planID}}"\n    },\n    "environment": {\n        "id": "{{envID}}"\n    },\n    "sourceStore": {\n        "id": "{{writebackStoreID}}"\n    },\n    "targetStore": {\n        "id": "{{sourceStoreID}}"\n    },\n    "name": "Workday Writeback Rule",\n    "description": "Workday writeback rule description",\n    "parentRule": {\n        "id": "{{parentRuleID}}"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "plan": {
    "id": "{{planID}}"
  },
  "environment": {
    "id": "{{envID}}"
  },
  "sourceStore": {
    "id": "{{writebackStoreID}}"
  },
  "targetStore": {
    "id": "{{sourceStoreID}}"
  },
  "name": "Workday Writeback Rule",
  "description": "Workday writeback rule description",
  "parentRule": {
    "id": "{{parentRuleID}}"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"plan\": {\n        \"id\": \"{{planID}}\"\n    },\n    \"environment\": {\n        \"id\": \"{{envID}}\"\n    },\n    \"sourceStore\": {\n        \"id\": \"{{writebackStoreID}}\"\n    },\n    \"targetStore\": {\n        \"id\": \"{{sourceStoreID}}\"\n    },\n    \"name\": \"Workday Writeback Rule\",\n    \"description\": \"Workday writeback rule description\",\n    \"parentRule\": {\n        \"id\": \"{{parentRuleID}}\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/propagation/plans/{{planID}}/rules")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "id": "12e82a11-26d2-4ca6-b221-0b55fd1200ac",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2022-10-11T14:39:43.040Z",
    "updatedAt": "2022-10-11T14:39:43.040Z",
    "plan": {
        "id": "70a2dd92-da36-449b-bd70-6a5955af1364"
    },
    "sourceStore": {
        "id": "fdad63d8-591c-4cb2-a682-1ce6989ffd88"
    },
    "targetStore": {
        "id": "4e1b141b-ba0c-4922-a592-c86f2f802b35"
    },
    "name": "Workday Writeback Rule",
    "description": "Workday writeback rule description",
    "active": false,
    "deprovision": false,
    "parentRule": {
        "id": "a114cb98-ddd5-4d72-961c-632ef41dc35c"
    },
    "_links": {
        "create": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/plans/70a2dd92-da36-449b-bd70-6a5955af1364/rules"
        },
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/12e82a11-26d2-4ca6-b221-0b55fd1200ac"
        },
        "update": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/12e82a11-26d2-4ca6-b221-0b55fd1200ac"
        },
        "delete": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/12e82a11-26d2-4ca6-b221-0b55fd1200ac"
        }
    }
}
```
